/*****************************************************************************
 * File:       COM_bridge.c
 *
 * Description:
 *
 * External Entity: 'VAʐM'  (COM)
 ****************************************************************************/

#include "sys_mechs.h"
#include "sys_user_co.h"
#include "O_objects.h"
#include "sys_init.h"
#include "O_V_object.h"
#include "O_V_events.h"

#include "COM_bridge.h"

#ifdef TOPPERS
/*******************************************************************************
 *  l𕶎ɕϊ
 *******************************************************************************/
static char *
convert(unsigned int val, int radix, const char *radchar, int width,
		int minus, int padzero, char * p)
{
	char	buf[12];
	int		i, j;

	i = 0;
	do {
		buf[i++] = radchar[val % radix];
		val /= radix;
	} while (val != 0);

	width -= minus;
	if (minus > 0 && padzero > 0) {
		*p++ = '-';
	}
	for (j = i; j < width; j++) {
		*p++ = (char)(padzero > 0 ? '0' : ' ');
	}
	if (minus > 0 && padzero <= 0) {
		*p++ = '-';
	}
	while (i > 0) {
		*p++ = buf[--i];
	}
	return p;
}

/*
 *  OtH[}bgpCu֐
 */
static char const raddec[] = "0123456789";
static char const radhex[] = "0123456789abcdef";
static char const radHEX[] = "0123456789ABCDEF";
#endif

/*****************************************************************************
 * Bridge:  printInt
 ****************************************************************************/
void
COM_printInt(
    const int ee_val )
{

  /* Insert your implementation code here... */
#ifdef TOPPERS
  char	buf[32];
  char *p;

  if (ee_val >= 0) {
    p = convert(ee_val, 10, raddec, 0, 0, 0, buf);
  }
  else {
    p = convert(-ee_val, 10, raddec, 0, 1, 0, buf);
  }
  serial_wri_dat(CONSOLE_PORTID, buf, (UINT)(p - buf));	/* j^ɃbZ[Wo */
#else
  printf("%d", ee_val);
#endif
}

/*****************************************************************************
 * Bridge:  printString
 ****************************************************************************/
void
COM_printString(
    const char * ee_msg )
{

  /* Insert your implementation code here... */
#ifdef TOPPERS
  unsigned int len = 0;

  while(ee_msg[len]){
      len++;
  }
  if(len > 0)
      serial_wri_dat(CONSOLE_PORTID, (char *)ee_msg, len);
#else
  printf("%s", ee_msg);
#endif
}

/*****************************************************************************
 * Bridge:  printEndl
 ****************************************************************************/
void
COM_printEndl()
{

  /* Insert your implementation code here... */
#ifdef TOPPERS
  serial_wri_dat(CONSOLE_PORTID, "\n", 1);
#else
  printf("\n");
#if 0
  fflush(stdout);
#endif
#endif
}


